apiVersion: batch/v1
kind: Job
metadata:
  name: rgw-access-public
spec:
  template:
    metadata:
      labels:
        name: rgw-access-public
    spec:
      containers:
        - name: test
          image: ghcr.io/utopia-planitia/helm-tests-image:latest
          envFrom:
            - secretRef:
                name: rgw-test-bucket-public
            - configMapRef:
                name: rgw-test-bucket-public
          command:
            - bash
            - -c
            - |
              set -euxo pipefail
              mc alias set rgw https://{{ .Values.rgw_public_domain }} ${AWS_ACCESS_KEY_ID} ${AWS_SECRET_ACCESS_KEY} # connect to minio
              [ "$(mc ls rgw | grep ${BUCKET_NAME} | wc -l)" -eq 1 ] # verify bucket exists
              echo hello > transfer-file # create local file
              mc cp transfer-file rgw/${BUCKET_NAME} # upload
              mc cp rgw/${BUCKET_NAME}/transfer-file transfer-file-returned # download
              diff transfer-file transfer-file-returned # compare original and transferred file
              mc rm rgw/${BUCKET_NAME}/transfer-file # delete file
              [ -z "$(mc ls rgw/${BUCKET_NAME})" ] # test file is missing
              mc mb --ignore-existing rgw/${BUCKET_NAME}/empty-directory/ # create directory/prefix in bucket
              mc stat rgw/${BUCKET_NAME}/empty-directory/ >/dev/null # test if the directory/prefix exists
      restartPolicy: Never
